#ifndef BleGamepadh
#define BleGamepadh
#include <Arduino.h>
#include <sdkconfig.h>

#if defined(CONFIG_BT_ENABLED) // 確認目標ESP32有啟用藍牙

#include "BleConnectionStatus.h"
#include <BLEHIDDevice.h>
#include <BLECharacteristic.h>

class BleGamepad
{
private:
	bool autoSendState;
	int8_t xAxis;
	int8_t yAxis;
	int8_t zAxis;
	int8_t zAxisRotation;
	uint32_t buttons;
	int16_t hatSwitch;

	BleConnectionStatus *connectionStatus;
	BLEHIDDevice *hid;
	BLECharacteristic *inputGamepad;
	static void taskServer(void *pvParameter);

public:
	BleGamepad(std::string deviceName = "ESP32 BLE Gamepad", std::string deviceManufacturer = "Espressif", uint8_t batteryLevel = 100);

	void begin(bool initAutoSendState = true);
	void end();

	void setXAxis(uint8_t value);
	void setYAxis(uint8_t value);
	void setZAxis(uint8_t value);
	void setZAxisRotation(uint8_t value);
	void setButton(uint8_t button, uint8_t value);
	void pressButton(uint8_t button);
	void releaseButton(uint8_t button);
	void setHatSwitch(int16_t value);
	void sendState();

	bool isConnected(void);
	void setBatteryLevel(uint8_t level);
	uint8_t batteryLevel;
	std::string deviceManufacturer;
	std::string deviceName;

protected:
	virtual void onStarted(BLEServer *pServer){};
};
// extern BleGamepad Gamepad;

#endif
#endif